
-- VHDL Test Bench Created from source file pd_led.vhd -- 13:44:54 07/04/2002
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE behavior OF testbench IS 

	COMPONENT pd_led
	PORT(
		CLK : IN std_logic;
		RST : IN std_logic;
		USB_DAT : IN std_logic_vector(7 downto 0);
		USB_RE : IN std_logic;          
		DISP_WR_N : OUT std_logic;
		DISP_ADR : OUT std_logic_vector(2 downto 0);
		DISP_DAT : OUT std_logic_vector(7 downto 0)
		);
	END COMPONENT;

  	constant PERIOD :      time := 54.253 ns;
	constant PERIOD_DATA : time := 200 ns;

	SIGNAL CLK :  std_logic := '0';
	SIGNAL RST :  std_logic := '0';
	SIGNAL USB_DAT :  std_logic_vector(7 downto 0);
	SIGNAL USB_RE :  std_logic := '0';
	SIGNAL DISP_WR_N :  std_logic;
	SIGNAL DISP_ADR :  std_logic_vector(2 downto 0);
	SIGNAL DISP_DAT :  std_logic_vector(7 downto 0);

BEGIN

	uut: pd_led PORT MAP(
		CLK => CLK,
		RST => RST,
		USB_DAT => USB_DAT,
		USB_RE => USB_RE,
		DISP_WR_N => DISP_WR_N,
		DISP_ADR => DISP_ADR,
		DISP_DAT => DISP_DAT
	);


-- *** Test Bench - User Defined Section ***
   tb : PROCESS
   BEGIN
      wait; -- will wait forever
   END PROCESS;
-- *** End Test Bench - User Defined Section ***

-- CLOCK
process begin
	wait for PERIOD/2;
	CLK <= not CLK;
end process;

-- RESET
process begin
	RST <= '1';
	wait for PERIOD;
	RST <= '0';
	wait ;
end process;

-- USB_RE
process begin
	wait for PERIOD*5;
	USB_RE <= not USB_RE;
   wait for PERIOD;
	USB_RE  <= '0';
end process;

-- USB_DAT
process begin
	
	wait for PERIOD*6;
	USB_DAT <= "00110001";
	wait for PERIOD*6;
	USB_DAT <= "00110010";
	wait for PERIOD*6;
	USB_DAT <= "00110011";
	wait for PERIOD*6;
	USB_DAT <= "00110100";
	wait for PERIOD*6;
	USB_DAT <= "00101010";
 
end process;

END;
